(local { : Gtk : Gdk : WebKit2 : cairo } (require :lgi))

(local command (require :command))

(fn new-frame []
  (let [hpad 2
        vpad 2
        window (Gtk.Window {
                            :title "Dunlin"
                            :default_width 800
                            :default_height 720
                            :on_destroy Gtk.main_quit
                            })
        container (Gtk.Box {
                            :orientation Gtk.Orientation.VERTICAL
                            })
        commander (Gtk.Entry {
                              :on_activate
                              (fn [event]
                                (command.invoke event.text {}))
                              })
        progress-bar (Gtk.ProgressBar {
                                       :orientation Gtk.Orientation.HORIZONTAL
                                       :fraction 1.0
                                       :margin 0
                                       })
        contentwidget (Gtk.Button {
                                   :label "paceholder"
                                   })
        ]
    (doto container
      (: :pack_start commander false false vpad)
      (: :pack_start progress-bar false false vpad)
      (: :pack_start contentwidget true true vpad))
    (window:add container)
    (window:show_all)
    window))

{ :new new-frame }
